#include "dict.h"
#include <stdio.h>
#include <stdlib.h>

static void go(dict_letter *l, int *w)
{
  dict_letter *t;

  if (*w == 0) return;

more:
  if (l->l == *w) {
    if (w[1] == 0) { l->w = 1; return; }
    if (l->child) { go(l->child, w+1); return; }
    w++;
    goto suffix;
  }
  if (l->next) { l = l->next; goto more; }

  t = l->next = malloc(sizeof(dict_letter)); if (!t) abort();

next:
  t->next = 0;
  t->child = 0;
  t->l = *w;
  t->w = w[1] ? 0 : 1;
  l = t;
  w++;
  if (!*w) return;
suffix:
  t = l->child = malloc(sizeof(dict_letter)); if (!t) abort();
  goto next;
}

void add_word(dictionary *d, int *w)
{
  go(d->top, w);
}

void new_dict(dictionary *d)
{
  d->top = malloc(sizeof(dict_letter)); if (!d->top) abort();
  d->top->next = 0;
  d->top->child = 0;
  d->top->l = -1;
  d->top->w = 0;
}

static int word[1024];
static int pos;

static void print(void)
{
  int i;
  for (i = 0; i < pos; i++) printf("%c", word[i] + 'A' - 1);
  printf("\n");
}

static void dodump(dict_letter *l)
{
next:
  if (!l) return;
  if (pos == 1024) abort();
  word[pos] = l->l; pos++;
  if (l->w) print();
  dodump(l->child);
  pos--;
  l = l->next;
  goto next;
}

void dump(dictionary *d)
{
  pos = 0;
  dodump(d->top->next);
}

static void dodump_cb(dict_letter *l, void (*cb)(int *))
{
next:
  if (!l) return;
  if (pos == 1024) abort();
  word[pos] = l->l; pos++;
  if (l->w) { if (pos==1024) abort(); word[pos] = 0; cb(word); }
  dodump_cb(l->child, cb);
  pos--;
  l = l->next;
  goto next;
}

void dump_cb(dictionary *d, void (*cb)(int *))
{
  pos = 0;
  dodump_cb(d->top->next, cb);
}

static int find(dict_letter *l, int *w)
{
  if (*w == 0) return 0;
  if (l == NULL) return 0;
next:
  if (l->l == *w) {
    if (l->w && w[1] == 0) return 1;
    return find(l->child, w+1);
  }
  l = l->next;
  if (l != NULL) goto next;
  return 0;
}

#if 0
char *get_word(int *w)
{
  int i;
  static char v[16];
  for (i = 0; w[i]; i++) v[i] = w[i] + 'A' - 1;
  v[i] = 0;
  return v;
}
#endif

int find_word(dictionary *d, int *w)
{
//printf("yo %s %d\n", get_word(w), find(d->top, w));
  return find(d->top, w);
}
