#include "dict.h"
#include "defs.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

dictionary dict;
wordlist wlist[16];

void usage(void)
{
  printf("usage: [options] <dictionary> <bag> <bottom word>\n");
  printf("option:\n");
  printf("    -nd\n");
  printf("        don't care of double letters in bottom word\n");
  printf("    -preplay <moves>\n");
  exit(0);
}

struct options options;

int main(int n, char **v)
{
  game g;
  char *fdict = NULL;
  char *bag = NULL;
  char *bottom = NULL;
  char *premoves = NULL;
  int i;
  int wordcount;
  char *ats = "A";

  for (i = 1; i < n; i++) {
    if (!strcmp(v[i],"-nd"))       { options.nd = 1; continue; }
    if (!strcmp(v[i],"-preplay")) {if(i>n-2)usage();premoves=v[++i];continue;}
#if 0
    if (!strcmp(v[i],"-ats")) {if(i>n-2)usage();ats=v[++i];continue;}
    if (!strcmp(v[i],"-z"))       { options.z = 1; continue; }
#endif
    if (fdict == NULL) { fdict = v[i]; continue; }
    if (bag == NULL) { bag = v[i]; continue; }
    if (bottom == NULL) { bottom = v[i]; continue; }
    usage();
  }
  if (fdict == NULL || bag == NULL || bottom == NULL) usage();

  if (!strcmp(ats, "A")) options.ats = A;
  else if (!strcmp(ats, "B")) options.ats = B;
  else if (!strcmp(ats, "C")) options.ats = C;
  else if (!strcmp(ats, "E")) options.ats = E;
  else if (!strcmp(ats, "Q")) options.ats = Q;
  else usage();

  new_dict(&dict);
  read_dict(fdict, &dict, 0);
  for (i = 2; i <= 15; i++) {
    init_wordlist(&wlist[i], i);
    dict_to_wordlist(&dict, &wlist[i], i);
  }

  wordcount = 0;
  for (i = 2; i <= 15; i++) {
    printf("words of length %d [%d]\n", i, wlist[i].size);
    wordcount += wlist[i].size;
  }
  printf("%d words in dict\n", wordcount);

  init_game(&g, bag);

  if (premoves != NULL) game_preplay(&g, premoves);

  if (strlen(bottom) != 15) usage();
  for (i = 0; i < 15; i++) {
    int l = bottom[i];
    if      (l >= 'a' && l <= 'z') l = l - 'a' + 1;
    else if (l >= 'A' && l <= 'Z') l = l - 'A' + 1;
    else usage();
    g.bottom[i] = l;
  }
  cut *getcut(int word[15], int *retlen);
  g.bottom_cut = getcut(g.bottom, &g.bottom_cut_size);

  void dig(game *);
  dig(&g);

exit(1);

  add_constraint_wordat(&g, WORDAT_ABSOLUTE, char2int("oxyphenbutazone"),
                        15, 0, 0);
  /* upper tripples must be played together */
  add_constraint_play_together(&g, 0, 0, 0, 7);
  add_constraint_play_together(&g, 0, 0, 0, 15);
  /* lower tripples must be played together */
  add_constraint_play_together(&g, 15, 0, 15, 7);
  add_constraint_play_together(&g, 15, 0, 15, 15);

  if (premoves != NULL) game_preplay(&g, premoves);

  print_board(g.board);
  print_hand(g.hand);
  printf("score %d\n", g.score);

  movelist l;
  init_movelist(&l);
  get_moves(&g, &l, &dict);
  printf("%d moves\n", l.size);
  for (i = 0; i < l.size; i++) {
    int k;
    for (k = 0; k < l.v[i].wordlen; k++) {
      int val = abs(l.v[i].word[k]) - 1;
      if (val >= 26) val = val - 26 + 'a';
      else          val = val + 'A';
      printf("%c", val);
    }
    printf("\t\trow %d col %d vert %d\t", l.v[i].row, l.v[i].col, l.v[i].vert);
    for (k = 0; k < 7; k++) printf(" %2d", l.v[i].next_hand[k]);
    printf("\t%d", l.v[i].score);
    printf("\n");
  }

  solve_constraints(&g);

  return 0;
}
