#include "dict.h"
#include "defs.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

dictionary dict;
wordlist wlist[16];

int (*word15)[15];
int word15_size;

void usage(void)
{
  printf("usage: [options] <dictionary> <bag> <list of word15>\n");
  printf("option:\n");
  printf("    -ndt\n");
  printf("        don't care of double letters in top word\n");
  printf("    -ndb\n");
  printf("        don't care of double letters in bottom word\n");
  exit(0);
}

struct options options;

int fail(void) { abort(); }
void read_w15(char *w15)
{
  char l[256];
  int i;
  FILE *f = fopen(w15, "r");
  if (f == NULL) { perror(w15); exit(1); }
  while (1) {
    if (fgets(l, 256, f) == NULL) break;
    word15_size++;
    word15 = realloc(word15, word15_size * 15 * sizeof(int));
    if (word15 == NULL) abort();
    for (i = 0; i<15; i++) word15[word15_size-1][i] =
      l[i] >= 'a' && l[i] <= 'z' ? l[i] - 'a' + 1 :
      l[i] >= 'A' && l[i] <= 'Z' ? l[i] - 'A' + 1 :
      fail();
  }
  printf("%d 15 letters' words\n", word15_size);
  fclose(f);
}

int main(int n, char **v)
{
  game g;
  char *fdict = NULL;
  char *bag = NULL;
  char *premoves = NULL;
  char *w15 = NULL;
  int i;
  int wordcount;

  for (i = 1; i < n; i++) {
    if (!strcmp(v[i],"-ndt"))       { options.ndt = 1; continue; }
    if (!strcmp(v[i],"-ndb"))       { options.ndb = 1; continue; }
    if (fdict == NULL) { fdict = v[i]; continue; }
    if (bag == NULL) { bag = v[i]; continue; }
    if (w15 == NULL) { w15 = v[i]; continue; }
    usage();
  }
  if (fdict == NULL || bag == NULL || w15 == NULL) usage();

  new_dict(&dict);
  read_dict(fdict, &dict, 0);
  for (i = 2; i <= 15; i++) {
    init_wordlist(&wlist[i], i);
    dict_to_wordlist(&dict, &wlist[i], i);
  }

  wordcount = 0;
  for (i = 2; i <= 15; i++) {
    printf("words of length %d [%d]\n", i, wlist[i].size);
    wordcount += wlist[i].size;
  }
  printf("%d words in dict\n", wordcount);

  read_w15(w15);

  init_game(&g, bag);

  if (premoves != NULL) game_preplay(&g, premoves);

  void dig(game *);
  dig(&g);

  return 0;
}
