#include "hole15.h"
#include "defs.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

extern dictionary dict;

static cut *cutword;
static int cutword_size;
static int no_double;

void addword(int w[15])
{
  cutword_size++;
  cutword = realloc(cutword, cutword_size * sizeof(cut));
  if (cutword == NULL) abort();
  memcpy(cutword[cutword_size-1], w, 15*sizeof(int));
}

int check_word(int *dw)
{
  int w[16];
  int i, p = 0;
  if (dw[0] || dw[7] || dw[14]) return 0;
  if (no_double == 0) {
    if (dw[3]) return 0;
    if (dw[11]) return 0;
  }
#if 0
  if (dw[1]) return 0;
  if (dw[2]) return 0;
#endif
  for (i = 0; i < 15; i++) {
    w[p] = dw[i];
    if (dw[i] == 0) {
      if (p > 1 && !find_word(&dict, w)) return 0;
      p = -1;
    }
    p++;
  }
  w[p] = 0;
  if (p > 1 && !find_word(&dict, w)) return 0;
  return 1;
}

void print_dword(int *dw)
{
  int i;
  for (i = 0; i < 15; i++)
    printf("%c", dw[i] ? dw[i]+'A'-1 : ' ');
  printf("\n");
}

void doword(int *w)
{
  int dw[15];
  int i, j, k;
  printf("do "); print_dword(w);
  for (i = 0; i < 7; i++) for (j = 0; j < _15[i].len; j++) {
    for (k = 0; k < 15; k++)
      if ((*_15[i].h)[j][k] == 0) dw[k] = w[k]; else dw[k] = 0;
    if (check_word(dw)) { printf("%d: ", i+1); print_dword(dw); addword(dw); }
  }
}

cut *getcut(int word[15], int *retlen, int _no_double)
{
  cut *ret;
  no_double = _no_double;
  if (cutword_size) free(cutword);
  cutword_size = 0;
  cutword = NULL;
  doword(word);
  *retlen = cutword_size;
  ret = malloc(cutword_size * sizeof(cut)); if (!ret) abort();
  memcpy(ret, cutword, cutword_size * sizeof(cut));
  return ret;
}
