#include "dict.h"
#include "defs.h"
#include <stdlib.h>
#include <stdint.h>

void init_movelist(movelist *l)
{
  l->v = NULL;
  l->size = l->maxsize = 0;
}

void free_movelist(movelist *l)
{
  if (l->maxsize) free(l->v);
}

void add_movelist(movelist *l, move *m)
{
  if (l->size == l->maxsize) {
    l->maxsize += 1024;
    l->v = realloc(l->v, l->maxsize * sizeof(move)); if (l->v==NULL) abort();
  }
  l->v[l->size] = *m;
  l->size++;
}

int is_letter(game *g, int i, int j)
{
  return i >= 0 && i < 15 && j >= 0 && j < 15 && g->board[i][j].bagpos != -1;
}
