#include "defs.h"
#include <stdlib.h>
#include <string.h>

#define DOUBLE_LETTER 1
#define TRIPLE_LETTER 2
#define DOUBLE_WORD   3
#define TRIPLE_WORD   4

#define DL DOUBLE_LETTER
#define TL TRIPLE_LETTER
#define DW DOUBLE_WORD
#define TW TRIPLE_WORD

int value[15][15] = {
{ TW,  0,  0, DL,  0,  0,  0, TW,  0,  0,  0, DL,  0,  0, TW  },
{  0, DW,  0,  0,  0, TL,  0,  0,  0, TL,  0,  0,  0, DW,  0  },
{  0,  0, DW,  0,  0,  0, DL,  0, DL,  0,  0,  0, DW,  0,  0  },
{ DL,  0,  0, DW,  0,  0,  0, DL,  0,  0,  0, DW,  0,  0, DL  },
{  0,  0,  0,  0, DW,  0,  0,  0,  0,  0, DW,  0,  0,  0,  0  },
{  0, TL,  0,  0,  0, TL,  0,  0,  0, TL,  0,  0,  0, TL,  0  },
{  0,  0, DL,  0,  0,  0, DL,  0, DL,  0,  0,  0, DL,  0,  0  },
{ TW,  0,  0, DL,  0,  0,  0, DW,  0,  0,  0, DL,  0,  0, TW  },
{  0,  0, DL,  0,  0,  0, DL,  0, DL,  0,  0,  0, DL,  0,  0  },
{  0, TL,  0,  0,  0, TL,  0,  0,  0, TL,  0,  0,  0, TL,  0  },
{  0,  0,  0,  0, DW,  0,  0,  0,  0,  0, DW,  0,  0,  0,  0  },
{ DL,  0,  0, DW,  0,  0,  0, DL,  0,  0,  0, DW,  0,  0, DL  },
{  0,  0, DW,  0,  0,  0, DL,  0, DL,  0,  0,  0, DW,  0,  0  },
{  0, DW,  0,  0,  0, TL,  0,  0,  0, TL,  0,  0,  0, DW,  0  },
{ TW,  0,  0, DL,  0,  0,  0, TW,  0,  0,  0, DL,  0,  0, TW  }};

typedef struct {
  int car;
  int value;
  int count;
} letter_score;

letter_score letters[] = {
  {   0, 0, 2 },           /* joker */
  { 'A', 1, 9 },
  { 'B', 3, 2 },
  { 'C', 3, 2 },
  { 'D', 2, 4 },
  { 'E', 1, 12 },
  { 'F', 4, 2 },
  { 'G', 2, 3 },
  { 'H', 4, 2 },
  { 'I', 1, 9 },
  { 'J', 8, 1 },
  { 'K', 5, 1 },
  { 'L', 1, 4 },
  { 'M', 3, 2 },
  { 'N', 1, 6 },
  { 'O', 1, 8 },
  { 'P', 3, 2 },
  { 'Q', 10, 1 },
  { 'R', 1, 6 },
  { 'S', 1, 4 },
  { 'T', 1, 6 },
  { 'U', 1, 4 },
  { 'V', 4, 2 },
  { 'W', 4, 2 },
  { 'X', 8, 1 },
  { 'Y', 4, 2 },
  { 'Z', 10, 1 },
};

int score_is_letter(letter board[15][15], int i, int j)
{
  return i >= 0 && i < 15 && j >= 0 && j < 15 && board[i][j].bagpos != -1;
}

static int line_score(letter board[15][15], int i, int j, int inci, int incj,
                      int *bag)
{
  int mulfac = 1;
  int score = 0;
  int nletters = 0;
  int plus_25 = 0;

  while (score_is_letter(board, i-inci, j-incj)) i-=inci, j-=incj;

  while (score_is_letter(board, i, j)) {
    int letter_mul = 1;
    if (board[i][j].value < 0) switch (value[i][j]) {
    case DW: mulfac *= 2; break;
    case TW: mulfac *= 3; break;
    case DL: letter_mul = 2; break;
    case TL: letter_mul = 3; break;
    }
    /* if no joker */
    if (bag[board[i][j].bagpos] != 0)
      score += letters[abs(board[i][j].value)].value * letter_mul;
    nletters++;
    i+=inci;
    j+=incj;
  }

  if (nletters == 1) return 0;
  return score * mulfac + plus_25;
}

int score(game *g, letter *w, int wlen,
          int starti, int startj, int inci, int incj)
{
  int s;
  int i, j, l;
  letter board[15][15];
  int used_letters = 0;
  memcpy(board, g->board, 15*15*sizeof(letter));
  for (l=0, i=starti, j=startj; l<wlen; l++, i+=inci, j+=incj)
    if (board[i][j].bagpos == -1) {
      board[i][j].bagpos = w[l].bagpos;
      board[i][j].value = -abs(w[l].value);
    }
  s = line_score(board, starti, startj, inci, incj, g->bag);
  for (l=0, i=starti, j=startj; l<wlen; l++, i+=inci, j+=incj) {
    if (board[i][j].value > 0) continue;
    used_letters++;
    s += line_score(board, i, j, incj, inci, g->bag);  /* other direction */
  }
  /* if all letters of (full) hand used, +50 */
  if (used_letters == 7) s += 50;
  return s;
}
