#include <stdio.h>
#include <stdlib.h>
#include "dict.h"
#include "holes.h"

void init_holes(hole *h, int wordlen, int count)
{
  int i;
  if (count > wordlen || wordlen > 15 || count > 7) abort();
  h->count = count;
  h->wordlen = wordlen;
  for (i = 0; i < count; i++) h->pos[i] = i;
}

#if 0
int next_holes(hole *h)
{
  int k = h->count-1;
next:
  h->pos[k]++;
  if (h->count-k <= h->wordlen - h->pos[k]) {
    int l, hole = h->pos[k]+1;
    for (l = k+1; l < h->count && hole < h->wordlen; l++, hole++)
      h->pos[l] = hole;
    return 1;
  }
  k--;
  if (k == -1) return 0;
  goto next;
}
#endif

int next_holes(hole *h)
{
  int l, hole;
  int k = h->count;
  do {
    k--; if (k == -1) return 0;
    h->pos[k]++;
  } while (h->count-k > h->wordlen - h->pos[k]);

  hole = h->pos[k]+1;
  for (l = k+1; l < h->count; l++, hole++)
    h->pos[l] = hole;
  return 1;
}
