#include "dictint.h"
#include <stdio.h>
#include <stdlib.h>

static unsigned new_letter(dictionary_int *d)
{
  if (d->data_size == d->data_maxsize) {
    d->data_maxsize += 2048;
    d->data = realloc(d->data, d->data_maxsize * sizeof(dict_letter_int));
    if (!d->data) abort();
  }
  d->data[d->data_size].next = 0;
  d->data[d->data_size].child = 0;
  d->data[d->data_size].l = 0;
  d->data[d->data_size].w = 0;
  d->data_size++;
  return d->data_size-1;
}

static void go(dictionary_int *d, unsigned l, int *w)
{
  unsigned t;
  unsigned nl;

  if (*w == 0) return;

more:
  if (d->data[l].l == *w) {
    if (w[1] == 0) { d->data[l].w = 1; return; }
    if (d->data[l].child) { go(d, d->data[l].child, w+1); return; }
    w++;
    goto suffix;
  }
  if (d->data[l].next) { l = d->data[l].next; goto more; }

  nl = new_letter(d);
  t = d->data[l].next = nl;

next:
  d->data[t].next = 0;
  d->data[t].child = 0;
  d->data[t].l = *w;
  d->data[t].w = w[1] ? 0 : 1;
  l = t;
  w++;
  if (!*w) return;
suffix:
  nl = new_letter(d);
  t = d->data[l].child = nl;
  goto next;
}

void add_wordint(dictionary_int *d, int *w)
{
  go(d, d->top, w);
}

void new_dictint(dictionary_int *d)
{
  d->data = 0;
  d->data_maxsize = 0;
  clear_dictint(d);
}

void clear_dictint(dictionary_int *d)
{
  d->data_size = 0;
  new_letter(d);
  d->top = new_letter(d);
  d->data[d->top].next = 0;
  d->data[d->top].child = 0;
  d->data[d->top].l = -1;
  d->data[d->top].w = 0;
}

#if 0
static int word[1024];
static int pos;

static void print(void)
{
  int i;
  for (i = 0; i < pos; i++) printf("%c", word[i] + 'A' - 1);
  printf("\n");
}

static void dodump(dict_letter *l)
{
next:
  if (!l) return;
  if (pos == 1024) abort();
  word[pos] = l->l; pos++;
  if (l->w) print();
  dodump(l->child);
  pos--;
  l = l->next;
  goto next;
}

void dump(dictionary *d)
{
  pos = 0;
  dodump(d->top->next);
}

static void dodump_cb(dict_letter *l, void (*cb)(int *))
{
next:
  if (!l) return;
  if (pos == 1024) abort();
  word[pos] = l->l; pos++;
  if (l->w) { if (pos==1024) abort(); word[pos] = 0; cb(word); }
  dodump_cb(l->child, cb);
  pos--;
  l = l->next;
  goto next;
}

void dump_cb(dictionary *d, void (*cb)(int *))
{
  pos = 0;
  dodump_cb(d->top->next, cb);
}
#endif

static int find(dictionary_int *d, unsigned l, int *w)
{
  if (*w == 0) return 0;
  if (l == 0) return 0;
next:
  if (d->data[l].l == *w) {
    if (d->data[l].w && w[1] == 0) return 1;
    return find(d, d->data[l].child, w+1);
  }
  l = d->data[l].next;
  if (l != 0) goto next;
  return 0;
}

int find_wordint(dictionary_int *d, int *w)
{
//printf("yo %s %d\n", get_word(w), find(d->top, w));
  return find(d, d->top, w);
}
