#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "defs.h"

#if 0
void *__libc_malloc(size_t size);
void *__libc_realloc(void *ptr, size_t size);

void *qmalloc(size_t size)
{
  void *p = __libc_malloc(size);
  printf("%p = malloc(%ld)\n", p, size);
  return p;
}
void *realloc(void *ptr, size_t size)
{
  void *p = __libc_realloc(ptr, size);
  printf("%p = realloc(%p, %ld)\n", p, ptr, size);
  return p;
}
#endif

/* global immutable data */
dictionary dict;
dictionary dictX[16];

/* global mutable data */
dictionary_int done_dict;

void populate_dictionary(dictionary *d, char *dict)
{
  FILE *f = fopen(dict, "r"); if (!f) { perror(dict); abort(); }
  while (1) {
    unsigned char n[128];
    int ni[128];
    int pos;
    int i;
    if (!fgets((char*)n, 128, f)) break;
    for (i = 0; i < 127 && n[i]; i++) if (isspace(n[i])) { n[i] = 0; break; }
    n[i] = 0;
    for (i = 0, pos = 0; n[pos]; i++, pos+=1) ni[i] = n[i];
    ni[i] = 0;
    for (i = 0; ni[i]; i++) {
      if (ni[i] >= 'a' && ni[i] <= 'z') ni[i] = ni[i] - 'a' + 1;
      else abort();
    }
    ni[i] = 0;
    add_word(d, ni);
    if (i >= 2 && i <= 15) add_word(&dictX[i], ni);
  }
  fclose(f);
  return;
}

void set_target(charABC *x, char *v)
{
  int i;
  for (i = 0; i < 15 && *v; i++, v++) {
    x[i].A = x[i].B = x[i].C = 0;
    if (v[0] >= 'a' && v[0] <= 'z') x[i].x = v[0]-'A'+1;
    else abort();
  }
  if (*v) abort();
}

int main(int n, char **v)
{
  charABC word15[15];  /* target word */
  solver_state s;
  int i;

  if (n != 3 || strlen(v[2])>100) { printf("gimme <dict> <bag>\n"); return 1; }

  /* init state */
  s.stacklen = 0;

  /* init bag */
  s.bag_size = strlen(v[2]);
  s.bag = malloc(s.bag_size); if (!s.bag) abort();
  for (i = 0; i < s.bag_size; i++) {
    s.bag[i].A = s.bag[i].B = s.bag[i].C = 0;
    if (v[2][i] >= 'A' && v[2][i] <= 'Z') s.bag[i].x = v[2][i]-'A'+1;
    else if (v[2][i] == '?') s.bag[i].C = 1;
    else { printf("bad bag\n"); return 1; }
  }
  for (i = 0; i < 27; i++) s.bag_count[i] = 0;
  for (i = 0; i < s.bag_size; i++) s.bag_count[s.bag[i].x]++;

  /* init dict */
  for (i = 0; i <= 15; i++) new_dict(&dictX[i]);
  new_dict(&dict);
  populate_dictionary(&dict, v[1]);
  new_dictint(&done_dict);

  /* init board/moves */
  memset(s.board, 0, 15*15);
  s.moves_size = 0;

  /* go */
#if 0
  while (1) {
    char w[17];
    int l = 0;
    int c;
    while (1) {
      c = getchar(); if (c == EOF) return 0;
      if (c == '\n') break;
      w[l] = c; l++;
    }
    w[l] = 0;
    set_target(word15, w);
    play_word(&s, word15, 15, 0, 14, 1);
  }
#endif
  if (!s.bag_size) abort();
  set_target(word15, "oxyphenbutazone");
  //set_target(word15, "you");
  /* try all hand positions */
  for (i = 0; i <= s.bag_size; i++) {
    int k;
    for (k = 0; k < 27; k++) s.bag_count[k] = 0;
    for (k = 0; k < i; k++) s.bag_count[s.bag[k].x]++;
    s.bag_pos = i;
    printf("start hand position %d\n", s.bag_pos);
    play_word(&s, word15, 15, 0, 14, 1);
    //play_word(&s, word15, 3, 6, 8, 1);
  }

  return 0;
}
