#ifndef _DEFS_H_
#define _DEFS_H_

#include "dict.h"

typedef struct {
  int row, col, vert;
  /* >0 if already there, <0 if new, abs(x)+26 for joker */
  int word[15];
  int wordlen;
  int score;
  int prelcount[27];
  int preboard[15];
} move;

typedef struct {
  move *v;
  int size;
  int maxsize;
} movelist;

typedef struct {
  int lcount[27];
  /* 1-26 for letter, 26+[1-26] for joker */
  int board[15][15];
  move moves[100];
  int msize;
  int score;
  move premoves[100];
  int do_premove[100];
  int must_play[100];
  int pmsize;
  int target_board[15][15];
} game;

typedef struct {
  dict_letter *l;
  int hl;         /* hand's value (to check for jokers) */
  int new;
} letterstack_elem;

typedef struct {
  letterstack_elem stack[15];
  int stacklen;
} letterstack;

typedef struct {
  game *g;
  letterstack *s;
  movelist *ml;
} world;

void init_game(game *);
void read_moves(game *, char *);
int score(game *, int *, int wlen, int starti,int startj,int inci,int incj);
void play_move(game *g, move *m);
void unplay_move(game *g, move *m);
void print_board(int b[15][15]);
void print_moves(game *g);
int find_word(dictionary *d, int *w);
void read_dict(char *fn, dictionary *dict, int reverse);
void skip_moves(game *g, int m);
void dig(game *g);
int is_positive_letter(int board[15][15], int row, int col);
int can_play_move(game *g, move *m);

#endif /* _DEFS_H_ */
