#ifndef _DICT_H_
#define _DICT_H_

typedef struct dict_letter {
  struct dict_letter *next;
  struct dict_letter *child;
  int l;
  int w;
} dict_letter;

typedef struct {
  dict_letter *top;
} dictionary;

typedef struct {
  int **w;
  int wordlen;
  int size;
  int maxsize;
} wordlist;

void new_dict(dictionary *);
void add_word(dictionary *, int *);
void dump(dictionary *);
void dump_cb(dictionary *, void (*)(int *));
int find_word(dictionary *, int *);

void read_dict(char *fn, dictionary *dict, int reverse);

void init_wordlist(wordlist *, int wordlen);
void dict_to_wordlist(dictionary *, wordlist *, int wordlen);

int *char2int(char *);

#endif /* _DICT_H_ */
