#include <stdio.h>
#include <stdlib.h>
#include "defs.h"

void usage(void)
{
  printf("usage: <dict> <board>\n");
  exit(1);
}

dictionary dict;

void read_board(game *g, char *board)
{
  int i, j;
  char *s = board-1;
  for (i = 0; i < 15; i++) for (j = 0; j < 15; j++) {
    int l;
    while (1) {
      s++;
      if (!*s) abort();
      if (*s == '.') { l = 0; break; }
      if (*s >= 'a' && *s <= 'z') { l = *s - 'a' + 1; break; }
      if (*s >= 'A' && *s <= 'Z') { l = *s - 'A' + 1; break; }
    }
    g->target_board[i][j] = l;
  }
printf("target board:\n");
print_board(g->target_board);
}

int main(int n, char **v)
{
  game g;
  char *dictfile = NULL;
  char *board = NULL;
  int i;

  for (i = 1; i < n; i++) {
    if (dictfile == NULL) { dictfile = v[i]; continue; }
    if (board == NULL) { board = v[i]; continue; }
    usage();
  }

  if (dictfile == NULL || board == NULL) usage();

  new_dict(&dict);
  printf("reading dict\n");
  read_dict(dictfile, &dict, 0);
  init_game(&g);
  read_board(&g, board);
  printf("digging...\n");
  dig(&g);
  return 0;
}
